unit Miner;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ExtCtrls, Menus,ShellAPI;

const
        W=16;  //  
        H=16;  //  
type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N3761: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N377tF21: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    ImageList1: TImageList;
    ImageList2: TImageList;
    ImageList3: TImageList;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    procedure N377tF21Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure N11Click(Sender: TObject);
    procedure N3761Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N16Click(Sender: TObject);
  private
    { Private declarations }
    MR:integer; //ʳ  
    MC:integer; //ʳ  
    NM:integer; //ʳ 
    nMin        :integer;
    nFlag       :integer;
    status      :integer;
    pole:array [0..21,0..31] of integer;
    procedure NewGame();
    Procedure Kletka(row,col,status:integer);
    Procedure ShowPole(status:integer);
    Procedure Open(row,col:integer);
    Procedure Knopka(Status,Vud:integer);
    Procedure ElektTimer(x,y,tim:integer);
    Procedure StartMis;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

uses SaperAbout,inchi;

procedure TForm1.Kletka(row, col, status: integer);
var
        x,y:integer;
begin
        Image2.Visible:=false;
        Image2.Visible:=true;
        x:=(col-1)*W+1;
        y:=(row-1)*H+1;
        if (status = 0) then
        Begin
              ImageList1.Draw(Image2.Canvas,x,y,0);
              exit;
        end;
        if (pole[row,col]<100) then
        Begin
              ImageList1.Draw(Image2.Canvas,x,y,0);
              if (status = 2) and (pole[row,col]=9) then
                ImageList1.Draw(Image2.Canvas,x,y,5);
              exit;
        end;
        ImageList1.Draw(Image2.Canvas,x,y,15);
        if (pole[row,col]=100) then exit;

        if (pole[row,col]>= 101) and (pole[row,col] <= 108) then
        Begin
             Case Pole[row,col] of
                     101:ImageList1.Draw(Image2.Canvas,x,y,14);
                     102:ImageList1.Draw(Image2.Canvas,x,y,13);
                     103:ImageList1.Draw(Image2.Canvas,x,y,12);
                     104:ImageList1.Draw(Image2.Canvas,x,y,11);
                     105:ImageList1.Draw(Image2.Canvas,x,y,10);
                     106:ImageList1.Draw(Image2.Canvas,x,y,9);
                     107:ImageList1.Draw(Image2.Canvas,x,y,8);
                     108:ImageList1.Draw(Image2.Canvas,x,y,7);
             end;
             exit;
        end;

        if (pole[row,col] >= 200) then
           Begin
             ImageList1.Draw(Image2.Canvas,x,y,1);
             if (Status = 2) and (pole[row,col] < 209)then
                 ImageList1.Draw(Image2.Canvas,x,y,4);
           end;

        if (pole[row,col] = 109) then
             ImageList1.Draw(Image2.Canvas,x,y,3);

end;


procedure TForm1.NewGame;
var
        row,col :integer; // 
        n       :integer; //ʳ 
        k       :integer; //ʳ  
begin
     for row := 1 to MR do
       for col := 1 to MC do
         Pole[row,col] := 0;
      Randomize;
      n:=0;
      repeat
        row := Random (MR) + 1;
        col := Random (MC) + 1;
        if (Pole[row,col]<>9) then
        begin
                pole[row,col]:=9;
                inc(n);
        end;
      until (n= NM);

      for  row:=1  to MR do
       for  col:=1  to MC do
       if Pole[row,col]<>9 then
        begin
             k:=0;
             if Pole[row-1,col-1]=9 then inc(k);
             if Pole[row-1,col  ]=9 then inc(k);
             if Pole[row-1,col+1]=9 then inc(k);
             if Pole[row  ,col-1]=9 then inc(k);
             if Pole[row  ,col+1]=9 then inc(k);
             if Pole[row+1,col-1]=9 then inc(k);
             if Pole[row+1,col  ]=9 then inc(k);
             if Pole[row+1,col+1]=9 then inc(k);
             Pole[row,col]:=k;
        end;
        Status  :=0;
        nMin    :=0;
        nFlag   :=0;
end;

procedure TForm1.ShowPole(status: integer);
var
        i,j:integer;
begin
        for i:=1 to MR do
         for j:= 1 to Mc do
           Kletka(i,j,status);
end;

procedure TForm1.N377tF21Click(Sender: TObject);
begin
      NewGame;
      ShowPole(status);
end;

procedure TForm1.N14Click(Sender: TObject);
begin
   ShellAbout( Handle, '', ' DCeres, 2004 .', Image3.Picture.Icon.Handle)
   // AboutBox.ShowModal;
end;

procedure TForm1.Open(row, col: integer);
begin
    if Pole[row,col] = 0 then
    Begin
        Pole[row,col] := 100;
        Kletka(row,col,1);
        Open(row  ,col-1);
        Open(row-1,col  );
        Open(row  ,col+1);
        Open(row+1,col  );

        Open(row-1,col-1);
        Open(row+1,col-1);
        Open(row+1,col+1);
        Open(row-1,col+1);
    end
    else
        if (Pole[row,col] < 100 ) and (Pole [row,col] <> -3) then
        Begin
           inc (Pole[row,col], 100);
           Kletka(row,col,1);
        end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
        row,col :integer;
begin
     NM:=99;
     MR:= 20;
     MC:= 30;
     N3761.Checked:=False;
     N11.Checked:=false;
     N10.Checked:=true;
     N9.Checked:=false;
     for row := 0 to MR+1 do
       for col := 0 to MC+1 do
         Pole[row,col] := -3;
     NewGame;
     Form1.ClientHeight:=54+Mr*H;
     Form1.ClientWidth:=13+MC*W;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
     ShowPole(Status);
     Image1.Canvas.Brush.Color:=Panel1.Color;
     Image1.Canvas.Pen.Color:=Panel1.Color;
     Image1.Canvas.Rectangle(0,0,Image1.Width,Image1.Height);
     Knopka(Status,4);
     ElektTimer(30,3,NM-nFlag);
end;

procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var col,row:integer;
begin
   if status = 2 then exit;

   if status = 0 then Status := 1;
   Knopka(Status,3);
   row:= Trunc(y/H) + 1;
   col:= Trunc(x/W) + 1;

   if Button = mbLeft then
   Begin
      if Pole[row,col] = 9 then
      Begin
         inc(Pole[row,col],100);
         status := 2;
         ShowPole(status);
      end
      else if Pole[row,col] < 9 then Open(row,col);
   end
   else
   if Button = mbRight then
    if Pole [row,col] > 200 then
    Begin
       dec(nFlag);
       dec(Pole[row,col],200);
       Image2.Visible:=false;
       x:= (col-1)*w + 1;
       y:= (row-1)*H + 1;
       ImageList1.Draw(Image2.Canvas,x,y,2);
       Image2.Visible:=True;
    end
    else
       if (Pole[row,col] < 100)and (status = 1) then
       Begin
          inc(nFlag);
          if Pole[row,col] = 9 then inc(nMin);
          inc(Pole[row,col],200);
          if (nMin = NM) and (nFlag = NM) then
          Begin
             status := 3;
             ShowPole(status);
          end
          else Kletka(row,col,status);
       end;
     ElektTimer(30,3,NM-nFlag);
end;


procedure TForm1.Knopka(Status, Vud: integer);
begin
     Image1.Visible:=false;
     //Image1.Canvas.Rectangle(0,0,);
     Case Status of
       0:ImageList3.Draw(Image1.Canvas,Image1.Width div 2-11,3,4);
       1:ImageList3.Draw(Image1.Canvas,Image1.Width div 2-11,3,Vud);
       2:ImageList3.Draw(Image1.Canvas,Image1.Width div 2-11,3,2);
       3:ImageList3.Draw(Image1.Canvas,Image1.Width div 2-11,3,1);
       end;
     if Vud = 0 Then ImageList3.Draw(Image1.Canvas,Image1.Width div 2-11,3,Vud);
     Image1.Visible:= True;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if (x> Image1.Width div 2 -11) and (x< Image1.Width div 2 +11) and
        (y>3) and (y< 26)and (Status <> 0)
     then
     Begin
        Knopka(Status,0);
        NewGame;
        ShowPole(Status);
     End;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    Knopka(Status,4);
end;

procedure TForm1.Image2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     Knopka(Status,4);
end;

procedure TForm1.ElektTimer(x, y, tim: integer);
var i:integer;
    Min:boolean;
begin
     Tim:=Tim mod 1000;
     Image1.Visible:=false;
     min:=Tim<0;
     if Min then Tim:=-tim;
     i:=0;
     repeat
           ImageList2.Draw(Image1.Canvas,x-i*13,y,11 - tim mod 10);
           tim:= tim div 10;
           inc(i);
     until tim =0;
     if min then
     Begin
          ImageList2.Draw(Image1.Canvas,x-i*13,y,0);
          inc(i);
     end;
     while i < 3 do
     Begin
          ImageList2.Draw(Image1.Canvas,x-i*13,y,1);
          inc(i);
     end;
     Image1.Visible:=true;
end;

procedure TForm1.N11Click(Sender: TObject);
begin
     NM:=10;
     MR:= 8;
     MC:= 8;
     StartMis;
     N11.Checked:=true;
     N3761.Checked:=false;
     N10.Checked:=false;
     N9.Checked:=false
end;

procedure TForm1.StartMis;
var row,col:integer;
begin
     for row := 0 to MR+1 do
       for col := 0 to MC+1 do
         Pole[row,col] := -3;
     NewGame;
     ShowPole(Status);
     Form1.ClientHeight:=54+Mr*H;
     Form1.ClientWidth:=13+MC*W;
     Image1.Canvas.Brush.Color:=Panel1.Color;
     Image1.Canvas.Pen.Color:=Panel1.Color;
     Image1.Canvas.Rectangle(0,0,Image1.Width,Image1.Height);
     Knopka(Status,4);
     ElektTimer(30,3,NM-nFlag);
end;

procedure TForm1.N3761Click(Sender: TObject);
begin
     NM:=40;
     MR:= 16;
     MC:= 16;
     StartMis;
     N3761.Checked:=true;
     N11.Checked:=false;
     N10.Checked:=false;
     N9.Checked:=false
end;

procedure TForm1.N10Click(Sender: TObject);
begin
     NM:=99;
     MR:= 20;
     MC:= 30;
     StartMis;
     N3761.Checked:=False;
     N11.Checked:=false;
     N10.Checked:=true;
     N9.Checked:=false

end;

procedure TForm1.N2Click(Sender: TObject);
begin
   Close;
end;

procedure TForm1.N9Click(Sender: TObject);
begin
     Form2.SpinEdit1.Text:=IntToStr(MR);
     Form2.SpinEdit2.Text:=IntToStr(Mc);
     Form2.SpinEdit3.Text:=IntToStr(NM);
     if Form2.ShowModal= mrOk then
     Begin
        MR:=StrToInt( Form2.SpinEdit1.Text);
        Mc:=StrToInt( Form2.SpinEdit2.Text);
        NM:=StrToInt(Form2.SpinEdit3.Text);
        StartMis;
        N3761.Checked:=False;
        N11.Checked:=false;
        N10.Checked:=false;
        N9.Checked:=true;
     end
end;

procedure TForm1.N16Click(Sender: TObject);
begin
    WinHelp(Form1.Handle,'Saper.hlp',HELP_CONTEXT,4);
end;

end.
